
-- exercise 1.1
bigger a b = if a > b then a else b

-- exercise 1.2
bigger3 a b c = if a > b
                then if a > c then a else c
                     else if b > c then b else c

-- exercise 1.3
square x = x * x
isodd x = x `mod` 2 /= 0
circle r = pi * square r

-- exercise 1.4
isTriangle a b c = a + b >= c && a + c >= b && b + c >= a

-- exercise 2.1
--   square already defined
double a = 2 * a
inc a = a + 1

-- exercise 2.2

halfP a b c = (a + b + c) / 2
area a b c =
  if isTriangle a b c
  then
    let p = halfP a b c in sqrt (p * (p-a) * (p-b) * (p-c))
  else -1

-- exercise 3.1
-- Definition using a pattern to distinguish the two cases
trigNum 1 = 1
trigNum n = n + trigNum (n-1)

-- Definition using guard conditions instead of a pattern
trigNum1 n | n == 1    = 1
           | otherwise = n + trigNum1 (n-1)

-- Definition using if expression
trigNum2 n = if n == 1
             then 1
             else n + trigNum2 (n-1)

-- exercise 3.3
fact 0 = 1
fact n = n * fact (n-1)

-- exercise 4.3
addUp []     = 0
addUp (x:xs) = x + addUp xs

-- exercise 4.4
factAlt n = product [1..n]

-- exercise 5.2
even n = n `mod` 2 == 0

-- exercise 5.3
sumAlt xs = foldr (+) 0 xs

-- exercise 5.4
productAlt xs = foldr (*) 1 xs

-- exercise 5.5
myAnd xs = foldr (&&) True xs
myOr xs = foldr (||) False xs

-- exercise 6.1 Euler Problem 1
isThreeOrFive x = x `mod` 3 == 0 || x `mod` 5 == 0
sum3or5 n = sum (filter isThreeOrFive [1..(n-1)])

-- ANSWER
-- *Main> sum3or5 10
-- 23
-- *Main> sum3or5 100
-- 2318

-- exercise 6.2 Euler Problem 6
diffSumSquare n = square (sum [1..n]) - sum (map square [1..n])

-- ANSWER
-- *Main> diffSumSquare 10
-- 2640
-- *Main> diffSumSquare 100
-- 25164150

-- exercise 6.3 Euler problem 4
-- this gives the digits in reverse order but that does not matter here
digits n | n < 10    = [n]
         | otherwise = (n `mod` 10) : digits (n `div` 10)

isPalindrome n = let ds = digits n in ds == reverse ds
makeProd as bs = [a*b | a<-as, b<-bs]
-- these functions get min and max number with given number of digits
minNdigits 1 = 1
minNdigits n = 10 * minNdigits (n-1)
maxNdigits n = (10 * minNdigits n) - 1

-- palindromes :: Int -> [Int]
palindromes m =
  let r = [minNdigits m .. maxNdigits m] in
     filter isPalindrome (makeProd r r)

maxPalindrome m = maximum (palindromes m)

-- ANSWER
-- *Main> maxPalindrome 2
-- 9009
-- *Main> maxPalindrome 3
-- 906609
